From 6cb2063a807b7dc2c3da9378db1c134b2e82a0a3 Mon Sep 17 00:00:00 2001
From: Shynur <one.last.kiss@outlook.com>
Date: Sun, 2 Jul 2023 18:15:02 +0800
Subject: [PATCH] Use first match in dir-local `auto-mode-alist'

* lisp/files.el (set-auto-mode): Reverse the reversed alist.
---
 lisp/files.el | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

diff --git a/lisp/files.el b/lisp/files.el
index 148f47cbc97..fc3b47082ea 100644
--- a/lisp/files.el
+++ b/lisp/files.el
@@ -3396,8 +3396,9 @@ we don't actually set it to the same mode the buffer already has."
     (unless done
       (with-demoted-errors "Directory-local variables error: %s"
 	;; Note this is a no-op if enable-local-variables is nil.
-        (let* ((mode-alist (cdr (hack-dir-local--get-variables
-                                 (lambda (key) (eq key 'auto-mode-alist))))))
+        (let* ((mode-alist (reverse (cdr (hack-dir-local--get-variables
+                                          (lambda (key)
+                                            (eq key 'auto-mode-alist)))))))
           (setq done (set-auto-mode--apply-alist mode-alist
                                                  keep-mode-if-same t)))))
     (and (not done)
-- 
2.39.1

